#!/usr/bin/env node

var spawn       = require('child_process').spawn,
    delimiter   = ";;;",
    next_id     = 1, // start at 1 to avoid falsiness
    reqs        = {}

var process = spawn('ruby',['-rchronic','-rjson','crutch.rb']) // FIXME: Should load gems fom array

process.stdin.setEncoding('utf8');
process.stdout.setEncoding('utf8');
process.stderr.setEncoding('utf8');


process.stderr.on('data', function (data) {
  console.log('got stderr: ',data);
});


process.stdout.on('data', function (data) {

  //console.log('from Ruby, got: ',data);

  String(data).split(delimiter).forEach(function(str){
    if (str == '') return false

    var res = JSON.parse(str),
        req = reqs[res.id]//,
        //req['res'] = res

    if (res['error']) {
      req.cb(res['error'])
    }else{
      var date = new Date(res['result'])
      req.cb(null,date,res['result'])
    }

    delete reqs[res.id]
  })

})


process.on('exit', function (code, signal) {
  console.log('child process terminated due to receipt of signal '+signal);
});


exports.parse = function(str,cb){
  str = str || 'now'
  if (!cb || typeof cb != 'function') throw new Error('You must supply a callback in the form: function(err, dateObj, dateString)')
  var id = next_id && next_id++  

  reqs[id] = {
    req: {
      id:id,
      method:'parse',
      params:str
    },
    cb: cb
  }

  process.stdin.write(
    JSON.stringify(reqs[id].req)+'\n'
  )
}

// example usage
// for (var i=1; i<40; i++){ 
//   exports.parse('December '+i+' 1979 '+i%12+':05am',function(err,date,string){
//     if (err) return console.log(err)
//     console.log(date)
//   })
// }
// 
// exports.parse('HURR DURR',function(err,date,string){
//   if (err) return console.log(err)
//   console.log(date)
// })
// 
// //exports.parse('This throws an error')
// process.stdin.end()